| Earth Observation Mission CFI Software Lib Software User Manual for JAVA |

Public Member Functions | Public Attributes

# EECFI.Coord Class Reference

Base class for Coord objects. More...

Inheritance diagram for EECFI.Coord:

List of all members.

## Public Member Functions
| Coord ()
| Class constructor.
| Coord (long csRef, long der, double p[], double v[], double a[])
| Class constructor.
native Geodetic | getGeodetic (ModelId modelId, long deriv) throws CfiError
| Get geodetic coordinates of the input cartesian vector; Assumption: Coordinates are given in EARTH FIXED CS, otherwise an error message will be thrown.
native void | setGeodetic (ModelId modelId, long deriv, Geodetic geo) throws CfiError
| Set the cartesian vector from the input geodetic coordinates (EARTH FIXED CS).
native Kepler | getKepler (ModelId modelId, long mode) throws CfiError
| Get Keplerian elements for the input satellite state vector.
native void | setKepler (ModelId modelId, Kepler kep) throws CfiError
| Set cartesian satellite state vector from input Keplerian elements.
native StarData | getRaDec (ModelId modelId, long deriv) throws CfiError
| Get the spherical coordinates of the Coord vector.
native void | topocentricToEf (ModelId modelId, long mode, long deriv, Coord topOrigin, Topocentric topo)
| Change topocentric to EF CS.
native Topocentric | efToTopocentric (ModelId modelId, long mode, long der, Coord topOrigin)
| Change EF to topocentric CS.
## Public Attributes
long | cs
| Coordinate system (enumeration value).
long | deriv
| Derivative flag that indicates which derivatives are computed.
double | pos []
| Position vector.
double | vel []
| Velocity vector.
double | acc []
| Acceleration vector.

## Detailed Description

Base class for Coord objects.

## Constructor & Destructor Documentation

EECFI.Coord.Coord | ( |  | ) |

Class constructor.

EECFI.Coord::Coord | ( | long | csRef,
|  | long | der,
|  | double | p[],
|  | double | v[],
|  | double | a[] |
| ) |  |  |

Class constructor.

Parameters:

  | csRef | Coord reference system.
  | der | Derivative.
  | p | Position vector.
  | v | Velocity vector.
  | a | Acceleration vector.

## Member Function Documentation

Topocentric EECFI.Coord::efToTopocentric | ( | ModelId | modelId,
|  | long | mode,
|  | long | der,
|  | Coord | topOrigin |
| ) |  |  |

Change EF to topocentric CS.

Parameters:

  | modelId | Model id.
  | mode | Flag to indicate if the input coordinates is location or a direction (ModeFlagEnum).
  | der | Flag to indicate if the first derivative has to be computed (XLCFI_NO_DER or XLCFI_DER_1ST).
  | topOrigin | Position of the topocentric CS in the EF CS.

Returns:
  Topocentric coordinates.

Geodetic EECFI.Coord::getGeodetic | ( | ModelId | modelId,
|  | long | deriv |
| ) |  |  | throws CfiError

Get geodetic coordinates of the input cartesian vector; Assumption: Coordinates are given in EARTH FIXED CS, otherwise an error message will be thrown.

Parameters:

  | modelId | Model Id.
  | deriv | derivative to be computed (XLCFI_NO_DER or XLCFI_1ST_DER).
  | deriv | derivative and mode to be computed. The possible values are possible: XLCFI_NO_DER or XLCFI_ITER_NO_DER : No derivatives are computed. The algorithm is based in the Bowring iterative method XLCFI_1ST_DER or XLCFI_ITER_1ST_DER: First derivatives are computed. The algorithm is based in the Bowring iterative method XLCFI_NO_ITER_NO_DER : No derivatives are computed. The algorithm is based in the Bowring direct method XLCFI_ITER_1ST_DER : First derivatives are computed. The algorithm is based in the Bowring direct method The Bowring iterative method is more accurate but it provides a poor runtime perfomance. The Bowring direct method is less accurate than the iterative method at the satellite height, but it provides a better runtime perfomance.

Kepler EECFI.Coord::getKepler | ( | ModelId | modelId,
|  | long | mode |
| ) |  |  | throws CfiError

Get Keplerian elements for the input satellite state vector.

Note: The position and velocity are expected to be in True of Date CS.

Parameters:

  | modelId | Model id.
  | mode | input keplerian elements type: XLCFI_KEPLER_MEAN or XLCFI_KEPLER_OSC.

Returns:
  Keplerian elements.

StarData EECFI.Coord::getRaDec | ( | ModelId | modelId,
|  | long | deriv |
| ) |  |  | throws CfiError

Get the spherical coordinates of the Coord vector.

- It gets RA and Declination if the input coordinates are equatorial coordinates.
- It gets galactic longitude and latitude if the input coordinates are galactic.

Note that Coord object must not be in XLCFI_EF CS.

Parameters:

  | modelId | Model id.
  | deriv | XLCFI_DER_1ST to compute proper motions and radial velocity (for galactic coordinates derivatives are not computed).

Returns:
  Spherical coordinates.

void EECFI.Coord::setGeodetic | ( | ModelId | modelId,
|  | long | deriv,
|  | Geodetic | geo |
| ) |  |  | throws CfiError

Set the cartesian vector from the input geodetic coordinates (EARTH FIXED CS).

Parameters:

  | modelId | Model id.
  | deriv | derivative to be computed (XLCFI_NO_DER or XLCFI_1ST_DER).
  | geo | Geodetic coordinates.

void EECFI.Coord::setKepler | ( | ModelId | modelId,
|  | Kepler | kep |
| ) |  |  | throws CfiError

Set cartesian satellite state vector from input Keplerian elements.

Parameters:

  | modelId | Model id.
  | kep | input keplerian elements.

void EECFI.Coord::topocentricToEf | ( | ModelId | modelId,
|  | long | mode,
|  | long | deriv,
|  | Coord | topOrigin,
|  | Topocentric | topo |
| ) |  |  |

Change topocentric to EF CS.

Parameters:

  | modelId | Model id.
  | mode | Flag to indicate if the input coordinates is location or a direction (ModeFlagEnum).
  | deriv | Flag to indicate if the first derivative has to be computed (XLCFI_NO_DER or XLCFI_DER_1ST).
  | topOrigin | Position of the topocentric CS in the EF CS.
  | topo | Topocentric coordinates.

## Member Data Documentation

double EECFI.Coord.acc[]

Acceleration vector.

long EECFI.Coord.cs

Coordinate system (enumeration value).

long EECFI.Coord.deriv

Derivative flag that indicates which derivatives are computed.

double EECFI.Coord.pos[]

Position vector.

double EECFI.Coord.vel[]

Velocity vector.